// Hauptprogramm
// RC5 Sender mit PIC12C508
//
// Variante mit einem Taster und 16 mglichen Codes
// ber drei Jumper an GP0,1,2,4
//
// Copyright 2000 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "rc5send.h" //Pindefinitionen
#include "protos.h"

#include "phasemod.c"

//Globale Flags und Rckgabevariablen

unsigned char tastbuf;  //Tastaturpuffer
unsigned char toggle;   //Togglebit
unsigned char comcode;  //Kommandocode
unsigned char buf;      //Zwischenergebnisse

void main()
{ 
 OSCCAL=W; //Als erstes den Kalibrierwert fr den int. RC-Oszi sichern
 
 CLRWDT;         //Laut Datenblatt vor ndern Prescaler fr TMR0

 OPTION=0b01000111; //Wake up on pin change, Pullups disabled, Timer0 int. Source

//Ich habe die Pullups abgeschaltet wegen der vier Code Jumper.
//Wenn die auf 0 liegen ziehen sie sonst auch bei SLEEP() Strom.
//Der Code wird durch direkte Verbindung nach +5V oder Masse eingestellt.
//GP3 bekommt dafr einen externen Pullupwiderstand

//Ein TimerClock = 1us * 256 = 256us
//Fr Delays unten
 
 TRIS=0b111011; 	//0=Ausgang, 1=Eingang

 GPIO=0b111011;  //Port einmal schreiben

 if(GPWUF==0) toggle=0; //Beim ersten einschalten Togglebit lschen

//Das hier weil auch das loslassen der Taste ein Wakeup erzeugt
//Das soll aber keinen Code auslsen !!
//Deshalb etwas warten bis der Taster entprellt hat.
//Danach wird er als offen gelesen und nichts passiert
 TMR0=0; while(TMR0<200); //50ms Totzeit

 tastbuf=GPIO; //Eingnge lesen, lowaktiv !!

 comcode=tastbuf&0x03; //Commandocode an GP0,1
 buf=tastbuf&0x30;     //Der Jumper an GP4,5
 buf>>=2;              //Zwei Bit nach rechts schieben
 comcode+=buf;         //In Commandocode einfgen
   			   
 tastbuf=~tastbuf; //GP3 ist lowaktiv !
 tastbuf&=0x08;    //GP3 ausmaskieren
   
 //Code nur senden wenn GP3 auf 0 ist
 if(tastbuf==0x08)
  {
   //Togglebit der Taste verndern
   if(toggle==1) //Gesetzt ?
    {
     toggle=0;         //Neues Togglebit
    }
   else //War nicht gesetzt
    {
     toggle=1;        //Neues Togglebit
    }
      
   PhaseMod(); //Codes 5x phasenmoduliert senden
   TMR0=0; while(TMR0<200); //50ms Totzeit
   PhaseMod();
   TMR0=0; while(TMR0<200); //50ms Totzeit
   PhaseMod();
   TMR0=0; while(TMR0<200); //50ms Totzeit
   PhaseMod();
   TMR0=0; while(TMR0<200); //50ms Totzeit
   PhaseMod();
   TMR0=0; while(TMR0<200); //50ms Totzeit

  }
    
 tastbuf=GPIO; //Laut Datenblatt soll man das machen vor SLEEP
 SLEEP;      //Wenn alles getan ist schlafen bis Taste gedrckt wird
                 //Bei WakeUp gibt es einen Reset !               
}

